unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, DB, ADODB, ExtCtrls, Registry,
  ComCtrls

;

type

  // Tipo para ordenar
  TADSortType = (stNone, StASC, stDESC);

  TFormMAin = class(TForm)
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    DataSource1: TDataSource;
    ADOTable1: TADOTable;
    Button2: TButton;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    Panel4: TPanel;
    lblSeparador: TLabel;
    mmSchema: TMemo;
    Panel5: TPanel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ADOTable1AfterOpen(DataSet: TDataSet);
    procedure StatusBar1Click(Sender: TObject);
  private
    { Private declarations }
    _LastSort:String;
    _LastSortType:TADSortType;

    procedure _WColumns(); 


  public
    { Public declarations }
  end;

var
  FormMAin: TFormMAin;

const
  STR_EMPTY = '';

implementation

{$R *.dfm}

USES
  ShellAPI;

procedure TFormMAin.Button1Click(Sender: TObject);
begin
  ADOTable1.Active := not ADOTable1.Active;

  // Arreglar el ancho...
  _WColumns();
  
end;

procedure TFormMAin.DBGrid1TitleClick(Column: TColumn);
begin

  // No activado?
  if not (ADOTable1.Active) then begin
    Exit;
  end;


  if (_LastSort = Column.FieldName) then begin
    // Cambiamos la ordenacion
    if (_LastSortType = stNone) then begin
      _LastSortType := stASC;
    end
    else if (_LastSortType = stASC) then begin
      _LastSortType := stDESC;
    end
    else begin
      _LastSortType := stASC;
    end;
  end
  else begin
    _LastSort := Column.FieldName;
    _LastSortType := stASC;  // por defecto el primero
  end;

  // Ordenar
  if (_LastSortType = stNone) then begin
    ADOTable1.Sort := STR_EMPTY;
  end
  else if (_LastSortType = stASC) then begin
    ADOTable1.Sort := Column.FieldName + ' ASC';
  end
  else begin
    ADOTable1.Sort := Column.FieldName + ' DESC';
  end;

end;

procedure TFormMAin.FormCreate(Sender: TObject);
begin
  _LastSort := STR_EMPTY;
  _LastSortType := stNone;
end;

procedure TFormMAin.FormShow(Sender: TObject);
var
  Reg: TRegistry;
  Str, StrName:String;
begin

  // Cargar el fichero
  StrName := ExtractFilePath(Application.ExeName) + 'schema.ini';
  // existe?
  if FileExists(StrName) then begin
    mmSchema.Lines.LoadFromFile(StrName);
  end;

end;

procedure TFormMAin.Button2Click(Sender: TObject);
begin
  ADOTable1.Active := False;
  if (ADOTable1.Filter = '') then begin
    ADOTable1.Filter := 'Cantidad = 1';
    ADOTable1.Filtered := True;
    Button2.Font.Style := Button2.Font.Style + [fsBold];
  end
  else begin
    ADOTable1.Filter := '';
    ADOTable1.Filtered := False;
    Button2.Font.Style := Button2.Font.Style - [fsBold];
  end;
  ADOTable1.Active := True;
end;

procedure TFormMAin.ADOTable1AfterOpen(DataSet: TDataSet);
begin
  // Arreglar el ancho...
  _WColumns();
end;

procedure TFormMAin._WColumns;
begin
  // Columnas
  if (ADOTable1.Active) then begin
    DBGrid1.Columns[0].Width := 120;

    if (DBGrid1.Columns.Count > 1) then begin
      DBGrid1.Columns[1].Width := 70;
    end;

    if (DBGrid1.Columns.Count > 2) then begin
      DBGrid1.Columns[2].Width := 70;
    end;
  end;
end;

procedure TFormMAin.StatusBar1Click(Sender: TObject);
begin
    ShellExecute(Handle,
             'open',
             'http://neftali.clubdelphi.com',
             nil,
             nil,
             SW_SHOW);
end;

end.
